<?php

declare(strict_types=1);

namespace Pinpoint\TaxSwitch\Plugin\Magento\Tax\Helper;

use Magento\Tax\Model\Config;
use Pinpoint\TaxSwitch\Api\ConfigHelperInterface;

/**
 * This class is responsible for intercepting methods in \Magento\Tax\Model\Config
 */
class ConfigPlugin
{
    /**
     * @var \Pinpoint\TaxSwitch\Api\ConfigHelperInterface
     */
    private $configHelper;

    /**
     * @inheritDoc
     */
    public function __construct(ConfigHelperInterface $configHelper)
    {
        $this->configHelper = $configHelper;
    }

    /**
     * @param Config                                          $subject
     * @param int                                             $result
     * @param bool|int|\Magento\Store\Model\Store|string|null $store
     *
     * @return int
     */
    public function afterGetPriceDisplayType(Config $subject, int $result, $store = null): int
    {
        if ($this->configHelper->isEnabled()) {
            $result = $subject::DISPLAY_TYPE_BOTH;
        }

        return $result;
    }

    /**
     * @param \Magento\Tax\Model\Config $subject
     * @param bool                      $result
     * @param                           $store
     *
     * @return bool
     */
    public function afterDisplayCartPricesBoth(Config $subject, bool $result, $store = null)
    {
        if ($this->configHelper->isEnabled()) {
            $result = $this->configHelper->isEnabled();
        }

        return $result;
    }
}
